var url = "https://www.securepaynet.net/gdshop/registrar/search.asp?prog_id=namecat&isc=DNGS105&checkAvail=1&domainToCheck=";
var space = "+";
var domCheck = "";
var TLD = ".com"; // the default TLD
var tldSelection = 0; // the default selection in the list of TLDs
var TLDs = [
	{label:'.com', value:'.com'},
	{label:'.info', value:'.info'},
	{label:'.us', value:'.us'},
	{label:'.net', value:'.net'},
	{label:'.org', value:'.org'},
	{label:'.biz', value:'.biz'},
	{label:'.ws', value:'.ws'},
	{label:'.mobi', value:'.mobi'},
	{label:'.me', value:'.me'},
	{label:'.name', value:'.name'},
	{label:'.asia', value:'.asia'},
	{label:'.tv', value:'.tv'},
	{label:'.cc', value:'.cc'},
	{label:'.de', value:'.de'},
	{label:'.eu', value:'.eu'},
	{label:'.jp', value:'.jp'},
	{label:'.be', value:'.be'},
	{label:'.at', value:'.at'},
	{label:'.am', value:'.am'},
	{label:'.fm', value:'.fm'},
	{label:'.ag', value:'.ag'},
	{label:'.gs', value:'.gs'},
	{label:'.ms', value:'.ms'},
	{label:'.nu', value:'.nu'},
	{label:'.sc', value:'.sc'},
	{label:'.tc', value:'.tc'},
	{label:'.tk', value:'.tk'},
	{label:'.vg', value:'.vg'},
	{label:'.co.uk', value:'.co.uk'},
	{label:'.me.uk', value:'.me.uk'},
	{label:'.org.uk', value:'.org.uk'},
	{label:'.co.nz', value:'.co.nz'},
	{label:'.net.nz', value:'.net.nz'},
	{label:'.org.nz', value:'.org.nz'},
	{label:'.cn', value:'.cn'},
	{label:'.com.cn', value:'.com.cn'},
	{label:'.org.cn', value:'.org.cn'},
	{label:'.net.cn', value:'.net.cn'},
	{label:'.tw', value:'.tw'},
	{label:'.com.tw', value:'.com.tw'},
	{label:'.org.tw', value:'.org.tw'},
	{label:'.idv.tw', value:'.idv.tw'},
	{label:'.jobs', value:'.jobs'}
];

function generateTLDSelector() // create popup list of Top Level Domains
{
	var select = document.getElementById ('tldSelector');

	while (select.hasChildNodes())
		select.removeChild(select.firstChild);

	var numberOfTLDs = TLDs.length; // count the number of TLDs in the list
	
	for (var n = 0; n < numberOfTLDs; n++) // create an <OPTION> element for each TLD in the list
	{	
	    	var element = document.createElement("option");
       		element.innerHTML = TLDs[n].label;
        	element.setAttribute("name",TLDs[n].label);
        	select.appendChild(element);
	}
    
    select.options[tldSelection].selected = true; // add the 'selected' attribute to the selected TLD option
    tldText.innerHTML = TLDs[tldSelection].label; // since the TLD popup list is invisible, set the text of the fake one to the same as the selected TLD's label
}

function selectTLD(select)
{
	tldText.innerHTML = TLDs[select.selectedIndex].label; // change the text of the fake TLD popup list to the same as the selected TLD's label
	tldSelection=select.selectedIndex;
	TLD = TLDs[select.selectedIndex].value; // set the TLD variable to the TLD popup list selection
}

function checkDomain(domainToCheck)
{
domainToCheck = domainToCheck.replace(/[\s]+/g,'+');
	if (domainToCheck == "")
	{
		clearSearch()
	}
	else
	{
		if (widget)
			widget.openURL(url + domainToCheck + "&TLD=" + TLD);
	}
}

function openNameCat(page)
{
	widget.openURL('http://namecat.com/' + page);
}

function setup() {
//	document.getElementById("default").src="Default.png";
	generateTLDSelector(); // create popup list of Top Level Domains
	createGenericButton(document.getElementById("doneButton"), "Done", hideBack, 50); // Apple 'Done' button
}


function mouseDown(event, id) 
{	
	event.target.src = "goButton-down.png";
}

function mouseUp (event, id) 
{
	event.target.src = "transparent.gif";
	checkDomain(document.getElementById('domainToCheck').value);
}


// Dashboard JS functions supplied by Apple
function showBack()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
        
    if (window.widget)
        widget.prepareForTransition("ToBack");
                
    front.style.display="none";
    back.style.display="block";
    exitflip(event);
    
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hideBack()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
        
    if (window.widget)
        widget.prepareForTransition("ToFront");
                
    back.style.display="none";
    front.style.display="block";
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
function mousemove (event)
{
    if (!flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}
function mouseexit (event)
{
    if (flipShown)
    {
        // fade in the info button
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}
function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();
                
        
    T = limit_3(time-animation.starttime, 0, animation.duration);
        
    if (T >= animation.duration)
    {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
        
    animation.firstElement.style.opacity = animation.now;
}
function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}


// These handlers show and hide the background circle:
function enterflip(event)
{
    document.getElementById('fliprollie').style.display = 'block';
}
function exitflip(event)
{
    document.getElementById('fliprollie').style.display = 'none';
}


// Version checking code
var updateAvailable = false;
var currentVersion;
var latestVersion ='';

function getKeyValue(plist, key) { 
   var xml_http = new XMLHttpRequest(); 
   xml_http.open("GET", plist, false); 
   xml_http.send(null); 
    
   var xml = xml_http.responseXML; 
   var key_value = null; 
   var nodes = xml.getElementsByTagName("dict")[0].childNodes; 

   for (var i=0; i < nodes.length; i++) { 
      if (nodes[i].nodeType == 1 && nodes[i].tagName.toLowerCase() == "key" && nodes[i].firstChild.data == key) { 
         if (nodes[i+2].tagName.toLowerCase() != "array") { 
            key_value = nodes[i+2].firstChild.data; 
         } else { 
            key_value = new Array(); 
            var ar_nodes = nodes[i+2].childNodes; 
            for (var j=0; j < ar_nodes.length; j++) { 
               if (ar_nodes[j].nodeType == 1) key_value.push(ar_nodes[j].firstChild.data); 
            } 
         } 
          
         break; 
      } 
   } 
    
   return key_value; 
}

function checkForUpdate()
{
	// determine the current version of this widget from the plist
	currentVersion = getKeyValue("Info.plist", "CFBundleVersion");
	
	// determine the current version available
	var req = new XMLHttpRequest();
	req.onload = function()
	{
		latestVersion = req.responseText;
		if ((latestVersion != '') && (latestVersion != null) && (latestVersion >= currentVersion)){
				updateAvailable = true;
				// show new version message if an update is available
				document.getElementById('newVersionAlert').style.display='block'; 
        	} else {
            	document.getElementById('newVersionAlert').style.display='none'; 
        }
	};
	req.open("GET", "http://namecat.com/dngLatestVersion.txt", true);
	req.setRequestHeader("Cache-Control", "no-cache");
	req.send(null);
}

